package taglibdemo;

import java.io.IOException;
import java.util.Hashtable;
import javax.servlet.jsp.*;
import javax.servlet.http.*;
import javax.servlet.jsp.tagext.*;

/**
 * Encodes special characters.
 */
public class EncodeHtmlTag extends BodyTagSupport {
    
    public int doAfterBody() throws JspException {
        BodyContent body = this.getBodyContent();
        String orig = body.getString();
        body.clearBody();int length = orig.length();
        StringBuffer result = new StringBuffer(Math.round(length * 1.1f));
        
        for(int i = 0; i < length; i++) {
            char c = orig.charAt(i);
            String translation = getTranslation(c);
            if (translation == null) {
                result.append(c);
            } else {
                result.append(translation);
            }
        }
        try {
            getPreviousOut().print(result.toString());
        } catch (IOException e) {
            throw new JspTagException("" + e);
        }
        return SKIP_BODY;
    }
    
    private static Hashtable translations = makeTranslationTable();
    private static Hashtable makeTranslationTable() {
        Hashtable table = new Hashtable();
        table.put(new Character('<'), "&lt;");
        table.put(new Character('>'), "&gt;");
        table.put(new Character('&'), "&amp;");
        table.put(new Character('\''), "&quot;");
        table.put(new Character('\n'), "<br>");
        table.put(new Character('\t'), "&nbsp;&nbsp;&nbsp;&nbsp;");
        return table;
    }
    public static String getTranslation(char c) {
        return (String) translations.get(new Character(c));
    }

}
